#!/home/john/local/bin/julia

"""

  GTK interface to ASI-ZWO camera control
  
"""  

using Gtk4, Gtk4.GLib

camera_id = "ZWO ASI 6200"
image_size = (9600,4800,16)
temperature_now = 0.0
temperature_set = -10.0
cool_flag = false
filter_name = "rp"
exposure = 60.0
count = 1
count_max = 500
file_base = "image_"
file_folder = "./"
file_name = file_base * string(count)

#
# These library functions may be used to build this camera controller
# For a complete list see the library function code
#

#   get_num_connected_cameras() returns an integer count
#   get_connected_devices() returns a list of connected devices
#   get_camera_property(id::Integer) returns ASI_CAMERA_INFO for this camera
#   get_serial_number(id::Integer) returns camera serial number
#   get_control_caps(id::Integer) returns ASI_CONTROL_CAPS for this camera 
#   get_control_value(id::Integer, control_type::ASI_CONTROL_TYPE) returns
#     a tuple (value, is_auto)
#   set_control_value(id::Integer, control_type::ASI_CONTROL_TYPE, value, 
#     auto::Bool=false)
#   set_gain(id, gain, auto=false) = 
#     set_control_value(id, ASI_GAIN, gain, auto)
#   set_exposure(id, exposure_microsec, auto=false)   =   
#     set_control_value(id,ASI_EXPOSURE, exposure_microsec, auto) 
#   set_roi_format(id::Integer, width, height, binning, img_type::ASI_IMG_TYPE)
#   get_roi_format(id::Integer)
#   set_roi_start(id::Integer, startx, starty)
#   get_roi_start(id::Integer) returns (startx, starty)
#   get_status(id::Integer)
#   open_camera(id::Integer)
#   close_camera(id::Integer)
#   init_camera(id::Integer)
#   start_exposure(id::Integer, is_dark=false)
#   stop_exposure(id::Integer)
#   get_exp_status(id::Integer) returns ASI_EXP_STATUS
#   pulse_guide_on(id::Integer, direction::ASI_GUIDE_DIRECTION)
#   pulse_guide_off(id::Integer, direction::ASI_GUIDE_DIRECTION)
#   capture_still(id::Integer) returns an array with the image


#
# These functions are fulfilled here using the library and other packages
#

# Camera selection

# Full image size

# Selected centered subframe size 

# Subframe on/off

# Temperature setpoint

# Cooler on/off

# Sensor temperature

# Expose on/off

# Exposure duration 

# Full path to FITS file storage 

# FITS file name for next image

# FITS header FIELD entry text


#
# These are additional user interface functions
#

# Set the base folder

# Set the base FITS name

# Set subframe size

# Toggle subframe on/off

# Set the image count for next image

# Set the image count maximum 

# Start a single exposure

# Start multi-frame exposures

# Stop exposure

# Set the controlled temperature

# Toggle temperature control on/off

# Input the FITS header FILTER entry

# Input the FITS header TARGET entry

# Toggle a preview display

# Exit the program


#
# User interface to the camera
#

# Set up the window

win = GtkWindow("ZWO Camera Control", 600, 200)
vbox = GtkBox(:v)
win[] = vbox
