  /* Set cooler and states */

  void asi_set_cooler_state(int state)
  {
    ASI_BOOL cooler_auto = ASI_FALSE;
    ASI_BOOL fan_auto = ASI_FALSE;
    long cooler_adu = 0;
    long fan_adu = 0;
    printf("Setting cooler state %d. \n", state);
    if (state == 1) 
    {
      cooler_auto = ASI_TRUE;
      fan_auto = ASI_TRUE;
      cooler_adu = 100;
      fan_adu = 100;
      ASISetControlValue(camera_id, ASI_COOLER_ON, cooler_adu, cooler_auto);
      ASISetControlValue(camera_id, ASI_FAN_ON, fan_adu, fan_auto);
    } 
    else 
    {    
      cooler_auto = ASI_FALSE;
      fan_auto = ASI_FALSE; 
      cooler_adu = 0;
      fan_adu = 0;   
      ASISetControlValue(camera_id, ASI_COOLER_ON, cooler_adu,  cooler_auto);
      ASISetControlValue(camera_id, ASI_FAN_ON, fan_adu, fan_auto);
    }
  }


  /* Get cooler states              */
  /*   0 = off                      */
  /*   1 = on and not at set point  */              
  /*   2 = at set point             */                     

  int asi_get_cooler_temperature(double *cooler_temperature)
  {

    long fan_adu = 0;
    ASI_BOOL fan_auto = ASI_FALSE;
    ASIGetControlValue(camera_id, ASI_FAN_ON, &fan_adu, &fan_auto);

    long cooler_adu = 0;
    ASI_BOOL cooler_auto = ASI_FALSE;
    ASIGetControlValue(camera_id, ASI_COOLER_ON, &cooler_adu, &cooler_auto);

    long target_temperature_adu = 0;
    ASI_BOOL target_temperature_auto = ASI_TRUE;
    ASIGetControlValue(camera_id, ASI_TARGET_TEMP, &target_temperature_adu, &target_temperature_auto);
    
    long temperature_adu = 0;
    double temperature = 0.0;
    ASI_BOOL temperature_auto = ASI_TRUE;
    ASIGetControlValue(camera_id, ASI_TEMPERATURE, &temperature_adu, &temperature_auto);
    temperature = temperature_adu;
    *cooler_temperature = temperature/10.0;

    if (ASI_TRUE == cooler_auto)
    {
    
      return 1;

    }
    else if (ASI_FALSE == cooler_auto)
    {
      return 0;
    }

    return 0;
  }
